using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;

namespace OktellPlugin
{
	/// <summary>
	///   , . 
	/// </summary>
	public class Control04 : System.Windows.Forms.UserControl
	{
		private System.ComponentModel.Container components = null;
		public delegate void SendTypeChangeHandler ( SendType sendType );
		public event Base.PluginQueryInvoker OnQuery;
		public enum SendType
		{
			Email,
			FaxManual,
			FaxAuto
		}


		private Control041 m_Control041 = new Control041 ();
		private Control042 m_Control042 = new Control042 ();

		#region Common
		public Control04()
		{
			InitializeComponent();
			this.Dock = DockStyle.Fill;
			FormType = SendType.Email;
			m_Control041.SndTypeChanged +=new SendTypeChangeHandler(SndTypeChanged);
			m_Control042.SndTypeChanged +=new SendTypeChangeHandler(SndTypeChanged);

			m_Control041.OnQuery +=new Base.PluginQueryInvoker(Query);
			m_Control042.OnQuery +=new Base.PluginQueryInvoker(Query);
		}

		/// <summary> 
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Component Designer generated code
		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			// 
			// Control04
			// 
			this.Name = "Control04";
			this.Size = new System.Drawing.Size(696, 440);

		}
		#endregion
		#endregion

		public SendType FormType
		{
			set 
			{
				switch ( value )
				{
					case SendType.Email:
						m_Control041.SndType = value;
						m_Control041.Parent = this;
						m_Control041.Email = Control02.Email;
						m_Control041.Visible = true;
						m_Control042.Visible = false;
						break;
					case SendType.FaxManual:
						m_Control042.SndType = value;
						m_Control042.Parent = this;
						m_Control042.Fax = Control02.Fax;
						m_Control042.Visible = true;
						m_Control041.Visible = false;
						break;
					case SendType.FaxAuto:
						m_Control042.SndType = value;
						m_Control042.Parent = this;
						m_Control042.Fax = Control02.Fax;
						m_Control042.Visible = true;
						m_Control041.Visible = false;
						break;
				}
			}
			get 
			{
				if (m_Control042.Visible)
					return m_Control042.SndType;
				else
					return SendType.Email;
			}
		}

		private void SndTypeChanged(SendType sendType)
		{
			FormType = sendType;
		}

		private string Query(string xml)
		{
			if ( OnQuery != null )
				return OnQuery (xml);
			else
				return null;
		}

	}
}
