using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;

namespace OktellPlugin
{
	/// <summary>
	/// Summary description for ControlBase.
	/// </summary>
	public class ControlParent : System.Windows.Forms.UserControl
	{
		public delegate void EditClickHandler ( Base.DBField EditValue );
		public delegate void FinishEditHandler (bool Cancel);

		public event Base.PluginQueryInvoker OnQuery;

		#region Fields
		private System.ComponentModel.Container components = null;
		#endregion

        Control01 m_Control01 = null;
        Control02 m_Control02 = null;
        Control03 m_Control03 = null;
        Control04 m_Control04 = null;

		#region Common
		public ControlParent()
		{

            //System.Reflection.Assembly [ ] assemblyes = AppDomain.CurrentDomain.GetAssemblies ();

            //string result = "";
            //for (int i = 0; i < assemblyes.Length; i++)
            //    result += assemblyes [ i ].FullName + "\r\n\r\n";

            //string probel = System.Text.Encoding.Unicode.GetString (new byte [ ] { 160, 0 });
            //result = result.Replace (" ", probel);

            //MessageBox.Show (result);

            try
            {
                m_Control01 = new Control01 ();
                m_Control02 = new Control02 ();
                m_Control03 = new Control03 ();
                m_Control04 = new Control04 ();

                InitializeComponent ();
                this.Dock = DockStyle.Fill;
                m_Control01.Parent = this;

                m_Control01.OnQuery += new Base.PluginQueryInvoker (Query);
                m_Control02.OnQuery += new Base.PluginQueryInvoker (Query);
                m_Control03.OnQuery += new Base.PluginQueryInvoker (Query);
                m_Control04.OnQuery += new Base.PluginQueryInvoker (Query);

                m_Control01.EditClick += new EditClickHandler (m_Control01_EditClick);
                m_Control02.OnFinish += new FinishEditHandler (m_Control02_OnFinish);
                m_Control03.OnFinish += new FinishEditHandler (m_Control02_OnFinish);
                //m_Control02.OnQuery +=new PluginBANK.Base.PluginQueryInvoker(Query);
            }
            catch
            {
            }
		}

		/// <summary> 
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Component Designer generated code
		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			// 
			// ControlParent
			// 
			this.Name = "ControlParent";
			this.Size = new System.Drawing.Size(600, 360);

		}
		#endregion
		#endregion

		public void SendFax()
		{
			m_Control01.Visible = false;
			m_Control02.Visible = false;
			m_Control03.Visible = false;

			m_Control04.FormType = Control04.SendType.FaxManual;
			m_Control04.Visible = true;
			m_Control04.Parent = this;
		}

		public void SendMail()
		{
			m_Control01.Visible = false;
			m_Control02.Visible = false;
			m_Control03.Visible = false;

			m_Control04.FormType = Control04.SendType.Email;
			m_Control04.Visible = true;
			m_Control04.Parent = this;
		}

		public int Mode
		{
			set
			{
				m_Control01.Visible = false;
				m_Control02.Visible = false;
				m_Control03.Visible = false;
				m_Control04.Visible = false;
				switch (value)
				{
					case 0:
						m_Control01.Visible = true;
						m_Control01.Parent = this;
						break;
					case 1:
						m_Control02.Visible = true;
						m_Control02.Parent = this;
						break;
					case 2:
						m_Control03.Visible = true;
						m_Control03.Parent = this;
						break;
					case 3:
						m_Control04.FormType = Control04.SendType.Email;
						m_Control04.Visible = true;
						m_Control04.Parent = this;
						break;
				}
			}
		}


		public void GetById ( int id, bool open )
		{
			m_Control01.GetByID ( id, open );
		}
		private string Query(string xml)
		{
			if ( OnQuery != null )
				return OnQuery (xml);
			else
				return null;
		}

		private void m_Control01_EditClick(Base.DBField EditValue)
		{
			try
			{
				Base.EditValue = m_Control02.EditValue = EditValue;
			

				m_Control01.Visible = false;
				m_Control02.Visible = true;
				m_Control02.Parent = this;

				Base.ChangeMode = 1;
				if (OnQuery != null )
				{
					if (EditValue.IsNew)
						OnQuery ( Base.Tabs2() );// 
					else
						OnQuery ( Base.Tabs3(1) );// 
				}
			}
			catch
			{
			}

		}

		private void m_Control02_OnFinish(bool Cancel)
		{
			if (!Cancel)
			{
				Base.DBField field = m_Control02.EditValue;

				#region  field  

				string recalldate = "";
				if (field.RecallDate!=DateTime.MinValue)
					recalldate = "'" + field.RecallDate.ToString("MM.dd.yyyy HH:mm:ss")  + "'";
				else
					recalldate = "NULL";

				//SQL- 
				string SQLtext = "Exec dbo.C_ClientsPlugin_Save " + ((field.IsNew)?1:0)  + ", " + field.Id  + ", '" + field.Name  + "', '" + field.Tip_work  + "', '" + field.Region_name  + "', " + field.Indeks  + ", '" + field.City  + "', '" + field.Adress  + "', '" + field.Phone  + "', '" + field.Fax  + "', '" + field.Email  + "', '" + field.Www  + "', '" + field.Fio  + "', '" + field.Dolgnost  + "', '" + field.Otdel  + "', " + field.Type  + ", " + field.Interes  + ", '" + field.Manager  + "', '" + field.Comment  + "', " + recalldate + "";

				//MessageBox.Show (SQLtext);

				// XML
				CMapperXmlItemSetCollection icoll = new CMapperXmlItemSetCollection (  );
				CMapperXmlItemSet iset = new CMapperXmlItemSet ();
				icoll.Add ( iset );
				iset.Name = "db";
				iset.Add ( CMapperXmlItem.GetItem ( "sqltext", SQLtext ) );
				string xml = icoll.WriteToXml ( "query" );

				int max = 0;
				bool error = true;
				if (OnQuery!=null)
				{
					string resxml = OnQuery (xml);

					#region  xml
					CMapperXmlItemSetCollection coll = CMapperXmlItemSetCollection.FromXml ( resxml );
					if ( coll != null )
					{

						for ( int i = 0; i < coll.Count; i++ )
						{
							CMapperXmlItemSet xset = coll[i];
							if ( xset.Name.ToLower() == "db" )
								for ( int j = 0; j<xset.Count; j++ )
								{
									if ( xset[j].Key.ToLower() == "resultcode" )
									{
										if ( xset[j].Value == "100" )
											error = false;
										break;
									}
								}
						}

						coll = coll [ 0 ].SubSets;
						CMapperXmlItemSetCollection coll2;
						CMapperXmlItemSetCollection coll3;

						if ( coll.Count > 1 )
						{
							CMapperXmlItemSet headset = null;
							CMapperXmlItemSet dataset = null;

							for ( int i = 0; i < coll.Count; i++ )
							{
								CMapperXmlItemSet tset = coll [ i ];
								switch ( tset.Name.ToLower() )
								{
									case "tableheader":
										headset = tset;
										break;

									case "tabledata":
										dataset = tset;
										break;
								}
							}

							if (( headset != null ) && ( dataset != null ))
							{
								Hashtable hash = new Hashtable ();

								#region  
								coll = headset.SubSets;
								//  
								for ( int i = 0; i < coll.Count; i++ )
								{
									CMapperXmlItemSet tset = coll [ i ];
									if (tset.Count > 0 )
									{
										string tmps = CMapperXmlItem.GetValueName ( tset[0] );
										string Id = tset.IdName;
										string Value = null;
										for ( int i4 = 0; i4 < tset.Count; i4++ )
											if ( tset[i4].Key.ToLower() == "name" )
												Value = CMapperXmlItem.GetValueName (tset[i4] );
										hash [ Id ] = Value;
									}
								}
								#endregion

								#region  
								coll2 = dataset.SubSets;
								//  
								if ( coll2.Count>0 )
								{
									for ( int i2 = 0; i2 < coll2.Count; i2++ )
									{						
										CMapperXmlItemSet tset = coll2 [ i2 ];
										coll3 = tset.SubSets;
										//  
										for ( int i3 = 0; i3 < coll3.Count; i3++ )
										{
											tset = coll3 [ i3 ];
											if (tset.Count > 0 )
											{
									
												string tmps = CMapperXmlItem.GetValueName ( tset[0] );

												switch ( (hash [tset.IdName] as string).ToLower() )
												{
													case "max":
														max = int.Parse(tmps);
														break;
												}

											}
										}
									}
								}
								#endregion
							}
						}

					}
					#endregion
				}
				#endregion

				if (!error)
					OnQuery (
						"<?xml version=\"1.0\" encoding=\"utf-16\"?>" +
						"<oktellxmlmapper version=\"80710\">" +
						"<data name=\"query\" count=\"1\">" +
						"	<property_set name=\"notify\">" +
						"	<property_cdata key=\"type\" ><![CDATA[info]]></property_cdata>" +
						"	<property_cdata key=\"text\"><![CDATA[]]></property_cdata>" +
						"	</property_set>" +
						"</data>" +
						"</oktellxmlmapper>"
						);

				//MessageBox.Show ( SQLtext );

				//  
				if ( field.IsNew )
				{
					field.Id = max;
					field.IsNew = false;
					m_Control01.AddField(m_Control02.EditValue);
				}
			}

			m_Control02.Visible = false;
			m_Control01.Visible = true;
			m_Control01.Parent = this;
			m_Control01.Refresh();

			Base.ChangeMode = 0;
			if (OnQuery != null )
				OnQuery ( Base.Tabs1() );// 
		}
	}
}
